// JavaScript Document
if (!ADMONITOR) var ADMONITOR = {};

ADMONITOR.accmanager = function() {

    var accounts = null;
    var currentAccount = null;
    var acc_file = null;
    var modify_cookie = false;
    var cookies_to_update = '';
    var cookie_keys = {
        //google : ['SID'],
        google : ['GALX','GAUSER','LSID','SID','SSID','HSID','NSID'],
        gmail : ['GX','SID','SSID','S','SS','GMAIL_IMP','GMAIL_ZY','GMAIL_AT','gmailchat'],
        googledoc : [	'WRITELY_SID', 'SS','SID'],
        yahoo : ['B','Y','T','sS','PH','F']
    };
    var cookie_host = {
        google : ['.google.com'],
        gmail :  ['.google.com','mail.google.com','.mail.google.com'],
        googledoc : [	'.google.com','docs.google.com', '.docs.google.com'],
        yahoo : ['.search.yahoo.com','.yahoo.com','search.yahoo.com'],
        bing : ['.bing.com']
    }; 
    var regexp_map = {
        yahoo : '^(http:\/\/search\.yahoo\.(co\.|com\.)?[a-z]{2,3}\/search\?.*?p=)([^&]*)(.*)$',
        google : '^((http|https):\/\/www.google\.(co\.|com\.)?[a-z]{2,3}\)([^&]*)(.*)$',
        gmail : '^((http|https):\/\/mail.google\.(co\.|com\.)?[a-z]{2,3})(.*)$',
        googledoc : '^((http|https):\/\/docs.google\.(co\.|com\.)?[a-z]{2,3})(.*)$',
        bing : '^(http:\/\/www\.bing\.com\/search\?.*?q=)([^&]*)(.*)$'
    }
    
    
    function cout(msg) {
      	ADMONITOR.utils._cout(msg);
  	}
    
    function getAccountFile() {
        if  (acc_file!= null) return acc_file;
        acc_file = ADMONITOR.utils._getProfileDir().clone();
	      acc_file.append("ADMONITOR");
	      if( !acc_file.exists() || !acc_file.isDirectory() ) 
	   	     acc_file.create(Components.interfaces.nsIFile.DIRECTORY_TYPE, 0777);
	   	  acc_file.append('accounts');
	   	  return acc_file; 
    } 
    
    function getFileSeedForCategory( category ) {
        if (category == '') return null;
        try{
          var proFile = ADMONITOR.utils._getProfileDir().clone();
          proFile.append("extensions");
          proFile.append("ad@monitor");
          proFile.append("CategortSeeds");
          proFile.append(category+'.tfidf.' + 'filtered')
          return proFile.clone();
        } catch (ex) { return null;}
    }
    
    function getRandomCategoryFromSeed() {
        var proFile = ADMONITOR.utils._getProfileDir().clone();
        proFile.append("extensions");
        proFile.append("ad@monitor");
        proFile.append("CategortSeeds");
        var entries = proFile.directoryEntries;
        var categoriesArray = [];
        while(entries.hasMoreElements())  {
          var entry = entries.getNext();
          entry.QueryInterface(Components.interfaces.nsIFile);
          if ( entry.leafName.indexOf('tfidf.filtered') > 0 )
              categoriesArray.push( entry.leafName.split('.')[0] );
        }
        var categories = '';
        for (var i=0; i< 2;i++) 
            categories +=   categoriesArray[ADMONITOR.utils._roll(0,categoriesArray.length)]+',';
        return categories.substring(0,categories.length-1);
    }
    
    function getAccountString() {
        var file = getAccountFile();
        var data = ADMONITOR.utils._getStringFromFile(file);
        if (data ==null) data= '{"children": [{ "id": "New", "cookie": "", "categories": "", "engine": "", "SV": "", "AV": ""  }]}';    
        return data; 
    } 
    
    function getAccount(id) {
        for each (var acc in accounts.children){
            cout(acc.id)
            if (acc.id == id) return acc 
        }
        return null;
    }
    
    function _getTMNRunningWindow() {
    		var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].
    							getService(Components.interfaces.nsIWindowMediator);
    		var en = wm.getEnumerator("navigator:browser");
    		 while (en.hasMoreElements()) { 
    	      var win = en.getNext(); 
    	      if (win.TRACKMENOT && win.TRACKMENOT.gTrackMeNot ) 
    	      	return win;
    	    }
	    return null;
    }  
    
    
    function _getValueForEngine(cookie_, engine) {
      var result = '';
      var val = '';
      //cout('Get Value For Cookie cookies : '+ cookie_ )
      for each (var key_ in cookie_keys[engine] ) {
            val = _getValueForKey ( cookie_,key_);
            if ( val != '') 
              result +=  val+';';
      }
      //cout('Updated cookies : '+ result )
      return result;
    }
    
   function _getValueForKey ( cookie_,key_) {
        var pairs = cookie_.replace(/\s/g,';').split(';'); 
        var value_ = pairs.filter(function(x){return (x.indexOf(key_+'=')==0)}); 
        //cout('Search key ' + key_ + ' in cookie ' +cookie_ + '    FOUND: ' + value_[0])
        if (value_.length == 0 ) return '';
        if (value_.length >1 ) {
           cout('Too many values for key ' + key_ + ' :  '+ value_);
           return value_[value_.length-1];
        } else {
          return value_[0];
        }
     }
     
     
     
      function _updateAccount ( id, new_cookie, categories, engine) {
        var acc = getAccount(id);
        //cout('Updating account ' + id)
        if ( new_cookie == null )  {
          accounts.children = accounts.children.filter(function(x) { return x.id != id});
          return;
        }
        if (acc == null) {
          cout('Can not update account with id: ' + id );
          acc = {};
          acc.id = id;
          acc.cookie = _getValueForEngine(new_cookie,engine);
          acc.categories = categories;
          acc.engine = engine;
          acc.SV = [];
          acc.AV = [];
          accounts.children.push(acc);       
        } else { 
          if ( new_cookie != '') acc.cookie =  _getValueForEngine(new_cookie,engine);
          if ( categories != '') acc.categories = categories;
          if ( engine != '') acc.engine = engine;
        }
        currentAccount = acc;
     }
     
     function eraseAndAdd(value_, host_) {
       
        var cookie_key = value_.split('=')[0];
        var nb_entries = 0;
        var expire = ';';
        var path = '/';
        var secure = '';
        var expireDate = new Date();
        var cookieMgr = Components.classes["@mozilla.org/cookiemanager;1"]
             .getService(Components.interfaces.nsICookieManager);
        for (var e = cookieMgr.enumerator; e.hasMoreElements();) {
          var cookie = e.getNext().QueryInterface(Components.interfaces.nsICookie); 
          if(cookie.host  ==  host_ && cookie.name == cookie_key ){
             if (cookie.expires) {
               expireDate.setTime(cookie.expires*1000)      
               expire = '; Expires='+ expireDate.toGMTString() +';';
              }
             path = cookie.path;
             secure = cookie.isSecure? '; Secure' : '';
             nb_entries++;
          }
        }
        if ( nb_entries==0) return
        var cm = Components.classes["@mozilla.org/cookiemanager;1"].
                             getService(Components.interfaces.nsICookieManager);
        for (var i=0;i<nb_entries; i++)
            cm.remove(host_,cookie_key,path,false);  
      // cout('Update ' + value_ + ' for host ' + host_)
        var cookieUri = Components.classes["@mozilla.org/network/io-service;1"]
          .getService(Components.interfaces.nsIIOService)
          .newURI('http://'+host_, null, null); 
        //_cout(cookieUri.spec)  
        cout('Set Cookie to:'+value_+';Domain='+host_+expire+' Path='+path+secure)
        Components.classes["@mozilla.org/cookieService;1"]      
          .getService(Components.interfaces.nsICookieService)
          .setCookieString(cookieUri, null, value_+'; Domain='+host_+expire+' Path='+path+secure+';',null);
        var string = Components.classes["@mozilla.org/cookieService;1"]      
          .getService(Components.interfaces.nsICookieService)
          .getCookieString(cookieUri,null);   
          cout('Cookie string is now: '+string ) 
     }
     
     function updateValuePair (value_,engine) {   
          for each (var  host_ in cookie_host[engine] ) {
              //cout( 'eraseAndAdd('+value_+','+host_+')' )
              eraseAndAdd(value_,host_);
          }
     }
     
     function setModifyFalse() {
        modify_cookie = false;
      }
     
     

return {


    _saveAccounts : function () {
      var file = getAccountFile();
  		var foStream = ADMONITOR.utils._getFoStream();
  		foStream.init(file, 0x02 | 0x08 | 0x20, 0664, 0);	
  	 	var jsonString = JSON.stringify(accounts);
  		foStream.write(jsonString, jsonString.length,'','iso-8859-1');
  		foStream.close();	   
    },
    
    _getCurrentAccount : function () {
      return currentAccount;
    },
    
        
    _setCurrentAccount : function (id) { 
         currentAccount = getAccount(id);
         ADMONITOR.accmanager._updateCookieForURL(currentAccount.cookie, currentAccount.engine );
         cout('currentAccount is : ' +id );
         //ADMONITOR.accmanager._sendQueryFromAccount(id);
         modify_cookie = true;
    },
    
    _restoreAccounts : function () {
        var accountString = getAccountString();
        try {
          accounts = JSON.parse(accountString);
        } catch (ex) {alert(ex)}
    },
    
    _getEngineFromUrl : function (url) {
        var regexMap =  null;  
        for (var eng in regexp_map) {
            regexMap =  new RegExp(regexp_map[eng],'g'); 
            if ( regexMap.test(url) )
              return eng;
        }
        return null;
    },
    
    _updateCurrentSearchVector : function ( vector ) {
        if ( currentAccount.SV == '') {
            currentAccount.SV = vector.slice()
            return
        }         
       for (var i=0; i<vector.length; i++)
          currentAccount.SV[i] += vector[i];  
    },
    
    _updateCurrentAdVector : function ( vector ) {
       if ( currentAccount.AV == '') {
            currentAccount.AV = vector.slice()
            return
        }   
       for (var i=0; i<vector.length; i++)
          currentAccount.AV[i] += vector[i]; 
    },
    
    
    _setCookieForUpdate : function (val){
      cookies_to_update += val+'; ';
    } ,
    
    _resultPageHandler : function (doc) {
        var url = doc.location.href;       
        var engine = ADMONITOR.accmanager._getEngineFromUrl(url);         
        if ( !engine) return;
        var new_cookie = doc.cookie;
        if(cookies_to_update != ''){
          new_cookie += cookies_to_update;
          //cout('Received cookies to update :'+cookies_to_update)
        } 
        cookies_to_update = '' ;
        cout('Doc cookie is :'+new_cookie  ) ;
        cout('Engine is :'+engine  )
        var accountName = engine+':'+ADMONITOR.adgraber._exctractAccountName(doc,engine);
        if ( accountName.indexOf('NotSignIn')>=0 )  return;             
         cout(accountName) 
         _updateAccount ( accountName, new_cookie, '', engine );
          //var brows = gBrowser.getBrowserForDocument(doc);
          //brows.removeEventListener("load", ADMONITOR.accmanager._resultPageHandler,false);
    },
    
    _resultPageHandlerEvt : function(evt) {
        var doc = window.content.document;
        ADMONITOR.accmanager._resultPageHandler(doc);
    },


    
    _updateCookieForURL : function (new_cookie, engine ) { 
         if (engine == '')  return;
         var values = new_cookie.split(';');
         for each( var val in values ) { 
            var key = val.split('=')[0].replace(/ /g,'');
            if( cookie_keys[engine].indexOf(key) >= 0 ){
                updateValuePair(val,engine);
            }
         }
         //values.forEach(updateValuePair);       
         return;
    },
    
      
    _getAccounts : function ( ) {
        return accounts
    },
    
    _modifyCookie : function ( ) {
        if ( modify_cookie && currentAccount.id == 'New') {
          setTimeout(setModifyFalse,10000);
          return true;
        }
        return false;
    },
    
    _getAccountCookie : function ( id ) {
        var acc = getAccount(id);
        if (acc!= null) return acc.cookie
        else return '';
    },
    
     _getAccountEngine : function ( id ) {
        var acc = getAccount(id);
        if (acc!= null) return acc.engine;
        else return 'google';
    },
    
    _getAccountCategories : function ( id ) {
        var acc = getAccount(id);
        if (acc== null) return null;
        if  (acc.categories == '' ){  // Get categories for ID from the file
           acc.categories = getRandomCategoryFromSeed();
        } 
        return acc.categories.split(',');
    },
    
    _sendQueryFromAccount : function ( id ) {
        var categories =  ADMONITOR.accmanager._getAccountCategories(id);
        var files = [];
        var winTMN = _getTMNRunningWindow();
        var gtmn = TRACKMENOT.utilsTMN.getTrackMeNot();
        //alert(gtmn)
        for each (var category in categories) {
             var file = getFileSeedForCategory( category );
             if(file!=null)
              files.push(file);                      
        } 
        gtmn._parseSeedUserFile(files); 
        gtmn._cookieAccountChanged = id;
        gtmn._searchEngines = ADMONITOR.accmanager._getAccountEngine(id);
        ADMONITOR.accmanager._setCurrentAccount(id);    
    },
    
    
    _init : function () {
        //ADMONITOR.accmanager._restoreAccounts();
       // ADMONITOR.accmanager._setCurrentAccount('New'); 
       // modify_cookie = false;
        
      //  var i= 1;
        //for each (var acc in accounts.children) {
        //    cout('Account is now :' + acc.id)
        //    if ( acc.id != 'New' && acc.id != 'undefined')
        //      setTimeout(ADMONITOR.accmanager._sendQueryFromAccount, (i++)*5*60000,acc.id) 
        //}    
    },



  }
  
  
  
}();
