if (!ADMONITOR) var ADMONITOR = {};

ADMONITOR.delicious= function() {
	
	const id = "ad@monitor";
	const extfile = Components.classes["@mozilla.org/extensions/manager;1"]
                    .getService(Components.interfaces.nsIExtensionManager)
                    .getInstallLocation(id)
                    .getItemLocation(id);  
    
    // Here are the objects that must be saved cause they're heavy               
    var d_catwords= [];
    var d_tags = [];
    var d_categories = [];
    var d_categories_full = [];
    var d_matrix = null;
    
    // These are simple to create
    var d_dbug = true;
    var d_cosines = [];
    var d_runs_array = [];
    var d_decode_progress = 0;
    var d_progress_window = null;
    var d_run_size = 0;
    var d_matrix_loaded = false;
    var d_free_slot = 100;
    var d_category_number = 1000;
    

  function _cout(msg) {
    	ADMONITOR.utils._cout(msg);
	} 
	

	
	function _getFileRawText(file) {				
		var istream = Components.classes["@mozilla.org/network/file-input-stream;1"].
		                        createInstance(Components.interfaces.nsIFileInputStream);
		istream.init(file, -1, -1, false);	
		var bstream = Components.classes["@mozilla.org/binaryinputstream;1"].
		                        createInstance(Components.interfaces.nsIBinaryInputStream);
		bstream.setInputStream(istream);	
		var bytes = bstream.readBytes(bstream.available());
		return bytes;
	}
		
	function _getJSONfromFile( filename ) {
		var file = extfile.clone()
    file.append( filename );
    var jsonStr = _getStringFromFile( file);
    var nativeJSON = Components.classes["@mozilla.org/dom/json;1"]
                 .createInstance(Components.interfaces.nsIJSON);
    var jsonObj = nativeJSON.decode( jsonStr );
    _categoriesToArray(jsonObj, null);
	}
	
	function _categoriesToArray( jsonObjs, father ) {
		var isroot = father == "All Categories"
		if (jsonObjs.name && jsonObjs.name != "All Categories") {
		  //d_category_number++;
			d_categories[jsonObjs.name] = [];
			d_categories_full[jsonObjs.id] = jsonObjs.name;
			d_categories[jsonObjs.name]["name"] = jsonObjs.name;
			d_categories[jsonObjs.name]["father"] = father;		
			d_categories[jsonObjs.name]["id"] = jsonObjs.id;		
			d_categories[jsonObjs.name]["bag"] = jsonObjs.name.replace('&','').toLowerCase() +
											   ( ( father && !isroot) ? " " + d_categories[father]["bag"] : "");
		}	
		for each( var chil in jsonObjs.children ) {
			_categoriesToArray(chil, jsonObjs.name);
		}
	}
		
	function _getStringFromFile(file) {
		var data = "";
		var fstream = Components.classes["@mozilla.org/network/file-input-stream;1"]
		                        .createInstance(Components.interfaces.nsIFileInputStream);
		var sstream = Components.classes["@mozilla.org/scriptableinputstream;1"]
		                        .createInstance(Components.interfaces.nsIScriptableInputStream);
		fstream.init(file, -1, 0, 0);
		sstream.init(fstream); 	
		var str = sstream.read(4096);
		while (str.length > 0) {
		  data += str;
		  str = sstream.read(4096);
		}
		sstream.close();
		fstream.close();
		return data;
	}


	
  function _decodeBytes( bytes, i ) {
    var new_run = true;
		var integer, mod=0,  base = 128;
		for ( ; (i < bytes.length) && ( i%10000!= 0 ||new_run); i++ ) {
			integer = 0, mod  = 0, new_run =false;
			var j = 0
			while (  (bytes.charCodeAt(i)& 0x80) == 128 )  {
				var temp = (-(bytes.charCodeAt(i++)& 0xff) & 0xff);
				integer += (temp-1)* Math.pow(base,mod++) ;	
			}
			integer += (bytes.charCodeAt(i)& 0xff) * Math.pow(base,mod++);
			d_runs_array.push(integer);
		}
		if( i < bytes.length) setTimeout(_decodeBytes,d_free_slot, bytes,i);
		else  setTimeout(_uncompressCosines, d_free_slot);
		/*alert(" Sum of the run is : " + d_run_size + " Size of the run matrix is :" +result.length )
		alert(" The error is : " + (d_run_size+result.length-733*20254) )     
		alert(result)    */
	}
	
	function _decodeCosine( encodedval ) {
		var multiplier = 32, shift_ = 41;
		if ( encodedval != 0 ) {
			var result = Math.exp( (shift_  - encodedval) / multiplier);
			if ( result && result != "undefined" ) return result.toFixed(4);
			else {
				_cout("Error in decoding cos value : " + encodedval );
				return 0;
			}
		 }	else 
	   		 return 0;
   	}
   	
   	    
    function _uncompressMatrix( ) { 
	      var cat_number = 733, tagNB = 20254;
        d_matrix = new Array( tagNB ) 
        d_matrix[0] = new Array( cat_number );
    		for ( var i = 0, j=0, c = 0, r = 0,l=0; i < d_runs_array.length ; i++ ) {
    	    	seq = d_runs_array[i];
    	    	for ( var k = 0; k < seq; k++, c++ ) {
    		    	d_matrix[r][c] = 0;
    		    	l++;
    		    	if ( c == (cat_number-1) ) {
    			    	c = -1;
    			    	d_matrix[++r] = new Array( cat_number );
    		    	}
    	    	}
     	    	d_matrix[r][c] = d_cosines[j++]
     	    	if ( j > d_cosines.length ) 
     	    		_cout ( "Overflow of the cosines matrix size" );
    	        if ( c == cat_number-1) {
    			    	  c = 0;
    			        d_matrix[++r] = new Array( cat_number );
    		      } else c++;
    	    }
    	    if (d_dbug) _cout('The _dmatrix length is ' + d_matrix.length)
    	    if ( l > (cat_number * tagNB ) ) 
    		    _cout ( " The number of entries  in the matrix " + l + " is too high" );	
    }
    
    function _uncompressMatrixThreaded( seq_index,  matr_index ) { 
        if (d_dbug)
          _cout("Running threaded decompration "+seq_index+"|"+matr_index)
	      var cat_number = 733, tagNB = 20254;
	      var line_nb = Math.floor( matr_index/cat_number);
	      var colu_nb = matr_index % cat_number;
	      var new_run = true;
	      if ( d_matrix == null ) {
          d_matrix = new Array( tagNB );
          for (var i= 0; i<d_matrix.length; i++ ) 
            d_matrix[i] = new Array( cat_number );    
        }    
    		for ( ; seq_index < d_runs_array.length && (seq_index%10000!=0 || new_run) ;seq_index++  ) {
    		    new_run = false; 
    	    	seq = d_runs_array[seq_index];
    	    	for ( var k = 0; k < seq; k++, colu_nb++ ) {
    		    	d_matrix[line_nb][colu_nb] = 0;
    		    	if ( colu_nb == (cat_number-1) ) {
    			    	colu_nb = -1;
    			    	d_matrix[++line_nb] = new Array( cat_number );
    		    	}
    	    	}
     	    	d_matrix[line_nb][colu_nb]= d_cosines[seq_index]
     	    	if ( seq_index > d_cosines.length ) 
     	    		_cout ( "Overflow of the cosines matrix size" );
    	      if ( colu_nb == (cat_number-1)) {
    			     colu_nb = 0;
    			     d_matrix[++line_nb] = new Array( cat_number );
    		    } else colu_nb++;
    	  }
    	  if ( seq_index < d_runs_array.length ) {
    	   setTimeout(_uncompressMatrixThreaded,d_free_slot, seq_index, (line_nb *cat_number)+colu_nb  )
    	   return;
    	  } else {
      	  if (d_dbug) _cout('The _dmatrix length is ' + d_matrix.length)
      	  d_matrix_loaded = true;
      	}
    }
    
       	
   	function _dumpMatrix(  ) {	
  		var file = extfile.clone();
  		file.append("matrix.txt");
  		foStream = ADMONITOR.utils._getFoStream();
  		foStream.init(file, 0x02 | 0x08 | 0x20, 0664, 0);	
  		
  		var converter = Components.classes["@mozilla.org/intl/converter-output-stream;1"].
                            createInstance(Components.interfaces.nsIConverterOutputStream);
      converter.init(foStream, "UTF-8", 0, 0);
      
  		for ( var i = 0; i< d_matrix.length; i++) { 
  		  var str =    d_matrix[i].join(',')
  			converter.writeString(str+'\r\n');
  		}
  		 converter.close(); // this close             
  	/*	_updateProgress(100,"ADMONITOR has been successfully installed. Thank you for your patience");
  		setTimeout(function() {d_progress_window.close();},2000);     */
    }
    

     function _dumpData( data, output ) {
   		var file = extfile.clone();	  
  		file.append(output);
  		foStream = ADMONITOR.utils._getFoStream();
  		foStream.init(file, 0x02 | 0x08 | 0x20, 0664, 0);	
  		foStream.write(data, data.length);
  		foStream.close()
    }
    
    function _matrixToString(matrix ) {
	    var result = "";
		  for ( var i=0; i< matrix.length-1; i++ ) {
			  for (var j = 0; j < matrix[i].length; j++) 
				  result += matrix[i][j] + ' '
			  result += '\n';
		  }
	    return result;
    }

    
  
   function _fileToArray(filename,array) {	   
	   var file = extfile.clone();
       file.append(filename);
                    
	   var istream = Components.classes["@mozilla.org/network/file-input-stream;1"]
			                   .createInstance(Components.interfaces.nsIFileInputStream);
			                   
	   istream.init(file, 0x01, 0444, 0);
	   istream.QueryInterface(Components.interfaces.nsILineInputStream);
			
		var line = {}, hasmore;
		do {
			hasmore = istream.readLine(line);
			array.push(line.value); 
		} while(hasmore);		
		istream.close();
	}
	
	function _fileToMatrix() {	   
	   var file = extfile.clone();
       file.append("matrix.txt");
       if ( !file.exists() ) return false;
	   var istream = Components.classes["@mozilla.org/network/file-input-stream;1"]
			                   .createInstance(Components.interfaces.nsIFileInputStream);
			                   
	   istream.init(file, 0x01, 0444, 0);
	   istream.QueryInterface(Components.interfaces.nsILineInputStream);
			d_matrix = new Array(20254)
		var line = {}, hasmore = true, temparray = [];
		for (var i =0; i < 20254 && hasmore; i++)  {
          hasmore = istream.readLine(line)
          d_matrix[i] = line.value.split(',').map(parseFloat); 
    }	
		istream.close();
		if (i== 20254) return true ;
		else {
      _cout("Matrix is not complete, need to reload it");
      return false;
    }
	}
	
	 
   function _isTag(word) {
	   if ( d_tags.indexOf( word ) >= 0 ) return true;
	   return false;
   }
   
   function _getIndexCatArray(word) {
   		return d_catwords.indexOf( word );   
   }
   
   function _getIndexTagArray(word) {
   		return d_tags.indexOf( word );
   }
	    
   function _simScore(bag, cat) {	
	    if (typeof(cat["bag"]) == 'undefined') return 0;   
		var catwords = cat["bag"].split(' ').map(stemmer).map(_getIndexCatArray);
		var scores = 0;
		var pos = false;
		var  n = 0;
		for ( var i = 0; i< bag.length; i++ ) {
		  try {
  				for ( var j = 0; j< catwords.length; j++ ) {
    						var score = Math.pow(d_matrix[bag[i]][catwords[j]],0.5);
    						if ( score > 0 ) {
    							pos = true;
    							scores+= score ;
    						}
    						n++;
  				}
			} catch (ex) {
          //_cout("Error for bag word " + bag[i])
      }
		}
		if ( n==0 ) return 0;
		else return scores/n;
    }

   	 function _getCategoryScore(cat, wordBagIndexes) {
		var result = new Array(2);
		result[0] = cat["name"];
		result[1] = _simScore(wordBagIndexes,cat);
		return result;
	}
	
	function _byScore(a,b) {
		return (b[1] - a[1] );
	}
	

	 
	 function _isNotPrivateCategory(cat) {
	      var category = d_categories[cat];
	      while ( category && category["name"] != "All Categories" ) {
           if (category["name"] == "Health" ) {
              //_cout("Forbidden category : " + category["name"]);
              return  false;
            }
            category = d_categories[category["father"]]
        }
        return true;	      
   }
   
   
   function _uncompressRuns() {
        var runs = extfile.clone();
	      runs.append("cosines.runs")
	      var bytes = _getFileRawText(runs);
	       _decodeBytes( bytes, 0);
   }
   
   function uncompressCosinesProc(values, index_) {
         var new_run = true;
         for (; (index_  <  values.length) && (index_%10000!= 0 || new_run) ; index_++ ) {    
            new_run = false;       
	        	d_cosines[index_] = _decodeCosine(values.charCodeAt(index_)& 0xff );
	        }
	        if (index_  <  values.length)  setTimeout(uncompressCosinesProc,d_free_slot, values, index_)
	        else setTimeout(_uncompressMatrixThreaded, d_free_slot,0,0);       
   }  
   
   function _uncompressCosines() {
    	  var vals = extfile.clone();
	      vals.append("cosines.values");
	      var values = _getFileRawText(vals);
	      d_cosines = new Array(values.length);
	      uncompressCosinesProc(values,0)	
   }
	 
   function filterCategories( catArray ) {
        var wordArray = [], result = [];
        for each ( var cat in catArray ) {
            if (cat[0]) {
              var words = cat[0].split(/\W/);
              if ( !words.some(function(x) { return (wordArray.indexOf(x)>=0 )} ) ) {
                 wordArray = wordArray.concat(words);
                 result.push(cat); 
              }
            }
        }
        return result; 
   }
	
	
	return {
		_getHierachy : function(cat) {
    		var category = d_categories[cat];
    		if (!category) return ""; 
    		var father = d_categories[category["father"]];
    		if ( father && father["name"] != "All Categories" ) 
    			return ADMONITOR.delicious._getHierachy(father["name"]) 
    				  		 + "->" + category["name"];
    		else
			return category["name"];
	 },
		
	 _getCategoryName : function( runs ) {
	    var cat_index = 0;
	    var categories_name = [];
	    for ( var j = 0; j< runs.length; j++ ) { 
	        cat_index +=  parseInt(runs[j]);
          categories_name.push( _getHierachy(d_categories_full[cat_index]))
      }
   		return categories_name;   
   },
   

   
	_decodeBytesFromRunFile : function () {  
    		/*var adn_save = Application.storage.get('ADMONITORSave', false);  
    		if( adn_save )    {
      		d_catwords= Application.storage.get('ADMONITORCatwords', []);
          d_tags = Application.storage.get('ADMONITORTags', []);
          d_categories = Application.storage.get('ADMONITORCategories', []);
          d_categories_full = Application.storage.get('ADMONITORCatFull', []);
          d_matrix = Application.storage.get('ADMONITORMatrix', null);
          return;
        } */
        
        _fileToArray("catwords", d_catwords);
         if (d_dbug) _cout( "Size of the category array : " + d_catwords.length )
        _fileToArray("toptags-utf8", d_tags );
        
        if (d_dbug) _cout( "Size of the tag array : " + d_tags.length )
        //_getJSONfromFile("google-cat-json");
        _getJSONfromFile("ad-preference-json");

        _uncompressRuns();
    }, 
    
        
    _getScore: function(word ,cat) {
        var st_word = stemmer(word);
        var st_cat = stemmer(cat);
        return d_matrix[_getIndexTagArray(st_word)][_getIndexCatArray(st_cat)]
    },
    
    _testMatrix : function () {
             var test_cat = document.getElementById("cat-entry").value;
             var test_tag = document.getElementById("tag-entry").value;
             var run_win = ADMONITOR.utils._getRunningWindow();
             var value = run_win.ADMONITOR.delicious._getScore(test_tag,test_cat );
             alert(value);
    } ,
    
		
    _bestCats : function (text) {
  	   var wordBagIndexes = text.map(stemmer).
  	   							 filter(_isTag).
  	   							 map(_getIndexTagArray);
  	  if(wordBagIndexes.length==0) return null;	
  	   if (d_dbug) {
  	      var stemWords = []; 
          for ( var i = 0; i < wordBagIndexes.length; i++) 
            stemWords.push(d_tags[wordBagIndexes[i]])
          _cout("Stem words :" + stemWords)
        }
       						 
  	   if (d_dbug) { _cout( "Wordbags for " + text + " are : " + wordBagIndexes ); }
  	   var catArray = [];
  	   
  	   for each( var cat in d_categories)   { 
       
  	     var cat_score =   _getCategoryScore(cat , wordBagIndexes );
  	      _cout( cat_score[1]) 
  	     if ( cat_score[1] > 0)
  	       catArray.push( cat_score );
       }

       catArray = filterCategories( catArray.sort(_byScore) );
       //catArray.forEach( function(x){_cout(x[0] + "has score "+ x[1] );} )		
   	   var bestcats = catArray.slice(0,5);
   	                          //.map( function(a){ return _getHierachy(a[0]); } );	
   	                          
   	   if ( bestcats.length == 0) { _cout("No category found"); return null;}
  	   else return bestcats; 
    }, 
    
    
    	_getHierachyArray : function(cat, result) {
    		var category = d_categories[cat];
    		if (!category) return ""; 
    		var father = d_categories[category["father"]];
    		result.push(category["name"]);
    		if ( father && father["name"] != "All Categories" ) 
    			ADMONITOR.delicious._getHierachy(father["name"],result);
    		//_cout(result);
	    },
	 
	 
     _categoriesToVector : function ( categories ) {
       var result = new Array(d_category_number);
       for (var i=0; i<result.length;i++) result[i]=0; 
  	   for each( var cat in categories) {
           var id = d_categories[cat]['id'];
           result[id] = 1;     
       }    
       return result;
    }, 
    
     _getRunsCategories : function( cats ) {
        var indexes = []
        for each(var cat in cats) {
            if( d_categories[cat] )
              indexes.push( d_categories[cat]['id'] )
            else _cout(cat)
        }
        indexes = indexes.sort(function(a,b){return a - b});
        var runs = [indexes[0]];
        for ( var i=0; i < indexes.length-1; i++)
            runs.push(indexes[i+1]-indexes[i])
     		return runs.join(',');   
     }, 
     
     _IsMatrixLoaded : function() {
        return  d_matrix_loaded; 
     },
     
     _getCategoryName : function (id) {
        return d_categories_full( id);
     }, 
     
      _getCategoriesNumber : function () {
        return d_category_number;
     }, 
     
     _getGoogleCatFile : function() {
        var file = extfile.clone()
        file.append( "ad-preference-json" );
        return file;
     }, 
     
     
     _getCategoryArray : function () {
        return d_categories;
     },
    
    }
		
}();
