// JavaScript Document
if (!ADMONITOR) var ADMONITOR = {};

ADMONITOR.historyManager = function() {

      var cc = Components.classes;
      var ci = Components.interfaces;
      var tsvc = cc["@mozilla.org/browser/tagging-service;1"]
                .getService(ci.nsITaggingService);
      var hsvc = cc["@mozilla.org/browser/nav-history-service;1"]
			          .getService(ci.nsINavHistoryService) ;
			var regexMap = {
          google : ".*?q=([^&]*)(.*)$",      
          yahoo :  ".*?p=([^&]*)(.*)$",
          bing : ".*?q=([^&]*)(.*)$",
          aol : ".*?query=([^&]*)(.*)$",
          ask : ".*?q=([^&]*)(.*)$"
     };
     var popularityArray = [];
     var sessionSearches = [];
     var totalSearches = 0;
     var searched = [];
     var searchSessions = [];
     var distance = [];
     var searchedIdx = 0;
     var searchURI = {
       google: 'http://www.google.com',
       yahoo: 'http://search.yahoo.com',
       bing: 'http://www.bing.com',
       baidu: 'http://www.baidu.cn'
      }  ;
    var dist_file = null;
    var pr_file = null;
    var resultWeek = {};
    var resultWeekEnd = {};
    var profile = null;
     


     Array.prototype.max = function() {
        var result =0;
        for( var i=0; i<this.length;i++) 
          if (result<this[i]) result = this[i];
        return result;
     }
     
      Array.prototype.maxIdx = function() {
        var result =0;
        for( var i=0; i<this.length;i++) 
          if (this[result]<this[i]) result = i;
        return result;
     }
     
      Array.prototype.secMaxIdx = function(curr) {
        var result =0;
        for( var i=0; i<this.length;i++) 
          if (this[result]<this[i] && i!=curr ) result = i;
        return result;
     } 


     function compare(a,b) {
      return b[1]-a[1];
     }
     

    function cout(msg) {
      	ADMONITOR.utils._cout(msg);
  	}
  	
  	function getProfileFile() {
        if  (pr_file!= null) return pr_file;
        pr_file = ADMONITOR.utils._getProfileDir().clone();
	      pr_file.append("ADMONITOR");
	      if( !pr_file.exists() || !pr_file.isDirectory() )  {
              pr_file.create(Components.interfaces.nsIFile.DIRECTORY_TYPE, 0777);
        }    
	   	  pr_file.append('profile');
	   	  if (!pr_file.exists() ) {
             pr_file = ADMONITOR.delicious._getGoogleCatFile();
         }
	   	  return pr_file; 
    }
    
    	function getProfileOutput() {
        pr_file = ADMONITOR.utils._getProfileDir().clone();
	      pr_file.append("ADMONITOR");
	      if( !pr_file.exists() || !pr_file.isDirectory() )  {
              pr_file.create(Components.interfaces.nsIFile.DIRECTORY_TYPE, 0777);
        }    
	   	  pr_file.append('profile');
	   	  return pr_file; 
    }  
    
  	
    function getProfile() {
        if (profile) return profile;
        
        var file =  getProfileFile();
        var profileString = ADMONITOR.utils._getStringFromFile(file);;
        try {
          profile = JSON.parse(profileString);   
        } catch (ex) {alert(ex)}    
        return profile;    
    } 
    
    
    function getDistFile() {
        if  (dist_file!= null) return dist_file;
        dist_file = ADMONITOR.utils._getProfileDir().clone();
	      dist_file.append("ADMONITOR");
	      if( !dist_file.exists() || !dist_file.isDirectory() ) 
	   	     dist_file.create(Components.interfaces.nsIFile.DIRECTORY_TYPE, 0777);
	   	  dist_file.append('hourly_dist');
	   	  return dist_file; 
    } 
     
     function getIndexOf(searched,keywords) {
       for (var i=0; i<searched.length; i++) 
            if (searched[i][0]==keywords) return i;
       return -1;
     }
     
     function getSimilarSession(word1,word2) {
          var result = 0;
          for (var sess in  sessionSearches[word1] )
            if(sessionSearches[word2][sess]) result++;       
          return result;
     }
     
     function computeSessionDistance(elt, array ) {
        var result = [];
        for (var i=0; i<array.length;i++)
            result.push(getSimilarSession(elt,array[i][0]))
        return result;
     }
     
     function getCorrelatedSearch(elt) {
         var second = elt.secMaxIdx(searchedIdx); 
         //alert(searched[searchedIdx++][0] + ' : '+ searched[second][0] )
     }
     
     function getKeywordCats(keywords) {
     	    var best_cats = ADMONITOR.delicious._bestCats( keywords );
	        if (best_cats == null) return null;
	        else {
            var p_categories = best_cats.map( function(a){ return ADMONITOR.delicious._getHierachy(a[0]); }) ;      	       
  	         cout( "Categories assigned to " + keywords + " are : " + p_categories) ;	       
  	        return p_categories;  
          }
    }
    
    function getCatByName( name_, father ) {
      var result = null;
      for each(var elt in father.children ) {
          if (elt.name == name_) result = elt;
          else result = getCatByName( name_,elt);
          if( result != null) return result;
      }
      return result;
    }
    
    function updateProfile(keywords) {
      var cats =  getKeywordCats(keywords);
      if(!cats) return null;
      var catArray = cats.join('->').split('->');
      for (var i=0; i<catArray.length;i++){
          var cat = getCatByName(catArray[i],profile);
          if (!cat.visit) cat.visit =1;
          else cat.visit++; 
      }
    
    } 
     
     function extractInfoResult(result) {
        var cont = result.root;
        profile = getProfile();
    		cont.containerOpen = true;
    		for (var i = 0; i < cont.childCount; i ++) {
      			var node = cont.getChild(i);
    	  		var url =  node.uri; 
    	  		var count =  node.accessCount; 
    	  		var search_ = url.split('?')[1];
    	  		if(search_) {
    	  		  var regex = new RegExp(regexMap['google'],"g");
    	  		  if ( search_.match(regex) )  {
        			  regex.exec(search_);
        			  keywords = RegExp.$1.replace(/\+/g,' ');
        			  var visit = node.QueryInterface(ci.nsINavHistoryVisitResultNode);
               	var session =  visit.sessionId; 
        	  		if (keywords )  {
        	  		  updateProfile(keywords.split(' ') );
          	  		if ( getIndexOf(searched,keywords)==-1 ) {
          	  		  searched.push([keywords,0]);
                    sessionSearches[keywords]= [];  
                  } 
                  var idx = getIndexOf(searched,keywords)
                  searched[idx][1]++;
                  sessionSearches[keywords][session]= 1;
                  totalSearches++;
                  //alert(keywords +" count: "+popularityArray[keywords] +" on: " + totalSearches )	    
                  //alert(keywords +" sessions: "+sessionSearches[keywords])	
                }
                          
              }
            }
		    }
		    ADMONITOR.historyManager._saveProfile();
		    searchedIdx = 0;
		    searched = searched.sort(compare);
		    distance = searched.map(function(x) {return computeSessionDistance(x[0],searched)});
		    distance.forEach(getCorrelatedSearch)
     }
     

     
     function weekBusinessFilter(today, i)   {
      return (today+7-i)%7>1;
     }
     
     function weekEndFilter(today, i)   {
      return (today+7-i)%7<2;
     }
     
     function  getSearchAt(hour,eng,dayfilter) {
        var start_ = (hour!=null)? hour :0;
        var end_ = (hour!=null)? (hour+1) : 24;
        var engine = (eng!=null)? eng : 'google';
        var weekQueries = [];
        var date = new Date();
        var today = new Date(date.getTime() - date.getTimezoneOffset()*60 * 1000).getDay();
        for (var i = 0; i < 7; i++) {
          if( dayfilter(today,i)(today+7-i)%7<2) {         
            var query = hsvc.getNewQuery();
          	query.beginTimeReference = query.TIME_RELATIVE_TODAY;
          	query.beginTime = (start_ -(i+1)* 24) * 60 * 60 * 1000000; // i+1 days ago
          	query.endTimeReference = query.TIME_RELATIVE_TODAY;
          	query.endTime = (end_-(i+1)*24) * 60 * 60 * 1000000; // i days ago
          	query.uriIsPrefix = true;
          	query.uri = makeURI(searchURI[engine]);
          	weekQueries.push(query);
        	}
      	}    
        var options_ = hsvc.getNewQueryOptions();
    		options_.sortingMode = 16 ;
    		options_.resultType = 1;
      	
      	
      	var result = hsvc.executeQueries( weekQueries, 2, options_);
      	var cont = result.root;
    		cont.containerOpen = true;
    		 cout("you made " + cont.childCount + " searches at " + start_ + " on " + engine)
    		//extractInfoResult(result)	
         return cont.childCount;
      }

    return {
    
      _getLastWeekSearchDist : function ( ) {
        for (var i = 0; i < 24; i++){
          var hourly = {};
          for (var eng in searchURI )  
            hourly[eng] =  getSearchAt(i,eng,weekBusinessFilter) ;
          resultWeek[i]= hourly;
        }
         ADMONITOR.historyManager._save(); 
     },
    
   /*  _getLastWeekSearch : function ( ) {
        getLastWeekSearchAt();
     }, */
     
    _getWeekEndSearchDist : function ( ) {    
      for (var i = 0; i < 24; i++){
          var hourly = {};
          for (var eng in searchURI )  
            hourly[eng] =  getSearchAt(i,eng,weekEndFilter);
          resultWeekEnd[i] = hourly;
        }
        ADMONITOR.historyManager._save(); 
     },  
     
  /*   _getWeekEndSearch : function ( ) {
           getSearchAt();     
     } ,    */
    
     _getSearchVisits : function( days ) {    
    	  if ( !days ) return;
    	                                	
    		var query = hsvc.getNewQuery();
    		//query.uriIsPrefix = true;
    		query.domain = 'www.google.com';
    		query.beginTimeReference = query.TIME_RELATIVE_NOW;
    		query.beginTime = - 5 * 24 * 60 * 60 * 1000000; // 24 hours ago in microseconds
    		query.endTimeReference = query.TIME_RELATIVE_NOW;
    		query.endTime = 0; // now

    
        var options_ = hsvc.getNewQueryOptions();
    		options_.sortingMode = 16 ;
    		options_.resultType = 1;
        //options.showSessions = true;
    
    		var result = hsvc.executeQueries( [query], 1, options_);
    		
    		extractInfoResult(result)
	  },
	  
	  _getLastWeekDist : function () {
        ADMONITOR.historyManager._getLastWeekSearchDist();
        ADMONITOR.historyManager._getWeekEndSearchDist();
    },
	  
	  _save: function () {
      var file = getDistFile();
      var composedResult = {};    
      composedResult.week = resultWeek;
      composedResult.weekend = resultWeekEnd;
  		var foStream = ADMONITOR.utils._getFoStream();
  		foStream.init(file, 0x02 | 0x08 | 0x20, 0664, 0);	
  	 	var jsonString = JSON.stringify(composedResult);
  	 	alert(jsonString)
  		foStream.write(jsonString, jsonString.length,'','iso-8859-1');
  		foStream.close();	   
    },
    
    
    _saveProfile: function () {
      var file = getProfileOutput();
  		var foStream = ADMONITOR.utils._getFoStream();
  		foStream.init(file, 0x02 | 0x08 | 0x20, 0664, 0);	
  	 	var jsonString = JSON.stringify(profile);
  	 	alert(jsonString)
  		foStream.write(jsonString, jsonString.length,'','iso-8859-1');
  		foStream.close();	   
    },
    
 
    
	  

}
 
  
  
}();
